# Siedler of Catan 
Siedler of catan is a multi-player-roleplay game, that lets you create settlements, 
build roads and upgrade settlements to cites in the world of catan.
You have to try to get the required amount of winpoints as fast as possible to come out as the winner.
You collect winpoints by owning settlements and cities and even get an extra two for owning the longest road.
It is also a strategic game, so you will have to choose wisely where to place your Structures.

## Rules
1. The minimum Player amount is 2 and the maximum Player amount is 4.
2. The minimum amount if win points is 3.
3. Each Player can build two roads and two settlements free of cost at the beginning of
the game. After placing the second settlement the players will each  receive the resources from around the second settlement.
4. Every Player receives a faction. There cannot be two players in the
same faction.
5. A player cannot build two settlements or cities right next one another. 
There have to be at least two roads between them.
6. The cost for each structure is set and is nonnegotiable.
7. The player with the longest road (most roads connecting to one another), which is longer than 4
will be awarded two additional winpoints.
8. If a player rolls a 7 on a dice throw, all player that are holding more than 7 resources, 
will lose half of all their resources. The resources that are being taken are chosen randomly.
9. Winpoints get awarded as following: (Settlement: 1), (City: 2), (Longest Road: 2)


For a more detailed version of the rules please look here: https://www.catan.de/sites/prod/files/2021-06/CATAN_DasSpiel_Spielregel.pdf

## How To Play
Setup Phase:
1. Enter the number of players that will be playing. (min 2, max 4)
2. Enter the number of winpoints needed to win the game. (min 3)
3. Each player is given a faction it is your as soon as the console says it is your faction's turn.
4. Every Faction will receive the possibility to place a settlement with a corresponding road. (no resource cost)
5. Play order is reversed and every faction receives a second settlement and a road to place. (no resource cost)
Each faction will afterwards receive the resources surrounding the second settlement.

After the setup phase the game phase will begin and continue until a winner emerges or the game gets quit via the quit command.

Navigate in the Game Phase:

>It is your turn as soon as the console shows it is your turn.

>To execute an action type in the associated number of the command which is showed in the terminal. 
Same applies when asked about resources.

> Note that the dice throwing gets done automatically before each turn,
and you get informed in the console which number has been chosen.
The resources will also be added to the corresponding factions automatically.

>You can do as many Commands as you like per turn. If decide to finish your turn, you can do so using  the next player command.


## Avaible Commands:
>``next player`` Ends a players turn and the next player turn will be started 


>``build settlement`` Builds a settlement at the chosen location.

You will be prompted to give coordinates for the settlement. If the coordinates are valid
and comply with all siedler rules a settlement of your faction will be build on the map.
If the coordinates aren't a valid position you will be prompted to input them again.
If there is an illegal move for example not enough resources or invalid field an error will be shown.



>``build city`` Builds a city at the chosen location.

You will be prompted to give the coordinates for an existing settlement. If the coordinates are valid
and comply with all siedler rules a city of your faction will be build on the map.
If the coordinates aren't a valid position you will be prompted to input them again.
If there is an illegal move for example not enough resources or invalid field an error will be shown.

>``build road`` Builds a road at chosen location.

You will be prompted to give two coordinate sets, the first coordinate of the start of the road and the second one
of the end of the road.If the coordinates aren't a valid position you will be prompted to input them again.
If there is an illegal move for example not enough resources or invalid field an error will be shown.



>``trade with bank`` Starts the trade with the bank 

You will first be prompted to input the resource that you offer.
Afterwards you will be prompted to input the resource that you would like to receive.
The Trade is in a 4 to 1 ratio, meaning that you give 4 resources to receive 1.
If you own the needed resources the trade will be completed.
If the bank doesn't have your desired resource, or you don't own enough resources of the one to give,
an error message will be shown.


>``quit`` Quits the game completely.

If a player wants to quit the game they can choose the command quit while it's their 
turn to quit the game. 

## Coordinates

![Coordinates](doc/Coordinates_SiedlerBoard.PNG)


## Class Diagram

![Class Diagramm](doc/classdiagram.png)